-- ====================================
-- DynaMo: Dynamic Module mission engine
--
-- Test Ground/Ground module resticted
--
-- For testing only
--
-- Cougar FFW04				25/02/2020
-- ===================================
local moduleName = " Test GGcombat "
local thisModule

local iniTreat = true	-- initial treatment flag
local coalitionTab = {"blue","red"}
local compagnyTaskTab = {"ARMOR","SUPPORT","ARTILLERY","AAA","SAM"}
local cloneProcSpacing = 4 -- time interval (sec) for cloning bataillon

nMaxBat = 12	-- maximum number of bataillon spawned (by camp so total is twice). CARE: this is not the number of vehicles !!!
meanVehSpeed = 85 -- Mean speed vehicle on road
--
blueARMORfrac, blueSUPPORTfrac, blueARTILLERYfrac, blueAAAfrac, blueSAMfrac = 0.25, 0.25, 0.20, 0.20, 0.10
redARMORfrac, redSUPPORTfrac, redARTILLERYfrac, redAAAfrac, redSAMfrac = 0.25, 0.25, 0.20, 0.20, 0.10
--
blueVehARMORperBat, blueVehSUPPORTperBat, blueVehARTILLERYperBat, blueVehAAAperBat = 9, 10, 7, 6 
redVehARMORperBat, redVehSUPPORTperBat, redVehARTILLERYperBat, redVehAAAperBat = 10, 12, 9, 6

blueARMORcompGroupList, blueSUPPORTcompGroupList, blueARTILLERYcompGroupList, blueAAAcompGroupList, blueSAMcompGroupList = ATME.C_IndexList(), ATME.C_IndexList(),  ATME.C_IndexList(), ATME.C_IndexList(), ATME.C_IndexList()
redARMORcompGroupList, redSUPPORTcompGroupList, redARTILLERYcompGroupList, redAAAcompGroupList, redSAMcompGroupList = ATME.C_IndexList(), ATME.C_IndexList(),  ATME.C_IndexList(), ATME.C_IndexList(), ATME.C_IndexList()

blueAreaTab, blueStratTargTab, blueAAAdefTab, blueSAMdefTab = {}, {}, {}, {}
redAreaTab, redStratTargTab, redAAAdefTab, redSAMdefTab = {}, {}, {}, {}

local createdBat = {}

-- ========================================================================================================
-- ========================================================================================================	

local function selectPos(_group,_wptName,_road)

	local pos, selZone = nil, nil
	local friendArea, ennemyArea = nil, nil
	local extZone, thickZone = nil, nil
	local dcsZone, selZoneName = nil, nil
	
	local coal = string.lower(_group:getCoalitionName())
	-- get group private datas
	local datas = _group:getUserPrivateDatas(thisModule)

	-- Choose red AND blue areas according to probability	
	for c = 1, #coalitionTab do
	
		local areaTab = _G[coalitionTab[c].."AreaTab"]
		-- Make sure that stratTarg exist for this area
		local randNum, areaId = nil, nil
		repeat
			areaId = 1
			randNum = math.random(0,100)
			while areaId < #areaTab and randNum > areaTab[areaId].cumProb do areaId = areaId + 1 end
		until areaTab[areaId].listTarg ~= 0
		
		-- Assign friend and ennemy areas
		if coalitionTab[c] == "blue" then 
			friendArea = areaTab[areaId]
		else 
			ennemyArea = areaTab[areaId] 
		end
	end
	
	-- Invert friend / ennemi if red 
	if coal == "red" then
		friendArea, ennemyArea = ennemyArea, friendArea
	end 
	
	-- Depearture position is at random for all in their respective area
	-- Same for destination bataillon
	if datas.task == "SUPPORT" or _wptName == "DEP" then
		selZoneName = friendArea.name
		selZone = ATME.C_Circle(selZoneName)
	
	-- Destination position depends on task for ARMOR/ARTILLERY/AAA/SAM
	elseif datas.task ~= "SUPPORT" then
					
		-- Define annulus ring for ARTILLERY
		if datas.task == "ARMOR" or datas.task == "ARTILLERY"  then
		
			local zoneTab = ennemyArea.listTarg 
			selZoneName = zoneTab[math.random(1,#zoneTab)]
			extZone, thickZone = 12., 3.
		
		-- Define annulus ring and check for already defended strategic place
		-- for AAA and SAM
		elseif datas.task == "AAA" or datas.task == "SAM" then
		
			local zoneTab = friendArea.listTarg 
			selZoneName = zoneTab[math.random(1,#zoneTab)]
			extZone, thickZone = 2., 1.	
	
			local tabToScan = _G[coal..datas.task.."defTab"]
			local keepIt = nil
			if #tabToScan > 0 then
				repeat
					for z, zName in pairs(tabToScan) do
						if zName == selZoneName then
							selZoneName = zoneTab[math.random(1,#zoneTab)]
							if z ~= #tabToScan then keepIt = false else keepIt = true end
						else
							table.insert(tabToScan,selZoneName)
							keepIt = true
							break
						end
					end
				until keepIt
			else
				table.insert(tabToScan,selZoneName)
			end

		end

		local dcsZone = ATME.getDCSZone(selZoneName)
		-- Create selZone annulus
		selZone = ATME.C_Circle(dcsZone.point,extZone*dcsZone.radius)
		selZone:changeThickness(thickZone*dcsZone.radius)
		
	end

	pos = selZone:getRandomPosition("LAND")
	if _onRoad then 
		pos.x, pos.z = land.getClosestPointOnRoads('roads',pos.x, pos.z)
	end

	return selZoneName, {x=pos.x, y=pos.z}

end


local function taskAtBatWPT(_batGroup,_wptDatas)

	local function pilonnage(_alarm)
		ATME.displayForAll(_alarm:getName().." FIRED !!",3)
		exploPower = math.random(150,220)
		ATME.explode(_alarm:getUserPrivateDatas().target:getRandomPosition(),exploPower)
		if _batGroup:getFirstUnit() ~= nil then
			_alarm:reschedule("RANDOM +1 +5")
		else
			_alarm:reschedule("1")
		end
	end

	ATME.displayForAll(_batGroup:getName().." reaches ".._wptDatas.name,1)
	local batDatas = _batGroup:getUserPrivateDatas(thisModule)

	if _wptDatas.name == "DES" then
		
		if batDatas.task == "ARTILLERY" then
			local nFire = math.random(30,60)
			local fireTarget = ATME.C_Circle(ATME.C_Circle(batDatas.targName):getCenter(),math.random(8,12)*0.1*ATME.C_Circle(batDatas.targName):getRadius())
			local batTask = ATME.C_Task("FIRE_AT_POINT",{circle = fireTarget, weaponType = nil, qty = nFire})
			_batGroup:setTask(batTask)
			-- simulate bombing in the area for realism
			local pilonAlarmName = "pilon".._batGroup:getName()
			local pilonAlarm = ATME.C_Alarm.createNamed(pilonAlarmName,"RANDOM +20 +25")
			pilonAlarmDatas = pilonAlarm:getUserPrivateDatas()
			pilonAlarmDatas.target = fireTarget 
			pilonAlarm:addCallback(pilonnage)
			pilonAlarm:addTriggeringsLimit(math.floor(2.*nFire),pilonnage)
		end
	end

end


local function agregateGroup(_group, _unitsToDiscard, _fromUnit)
	
	local nVeh = _group:getNbUnits()
	
	local cloneUnit = _group:getFirstUnit()
	for u = _fromUnit, _group:getNbUnits(), 1 do
		if not _unitsToDiscard or (#_unitsToDiscard > 0 and _unitsToDiscard[u] == -1 ) then
			cloneUnit:disable()
			nVeh = nVeh - 1
		end
		cloneUnit = _group:getNextUnit()
	end
	
	if not _unitsToDiscard then
		_group:getUserPrivateDatas(thisModule).agregated = true
	end
	
	return _group:getFirstUnit()
end


local function cloneAgDeagCallback(_cloneAgDeagCont, _cloneGroup)

	local function delayUnfreeze()
		_cloneGroup:freeze(false)
	end

	-- Return a table where if val = -1 if units must be discarded
	local function keepVeh(_taskGroup)

		local selUnits = {}
		local nRem, nInBat = 0, _cloneGroup:getNbUnits()
		for u = 1, nInBat do table.insert(selUnits,u) end

		if _taskGroup ~= "SAM" then
			local nMeanVhec = _G[string.lower(_cloneGroup:getCoalitionName()).."Veh".._taskGroup.."perBat"]
			local nVeh = math.random(math.floor(0.8*nMeanVhec),math.ceil(1.3*nMeanVhec))
			local nToDiscard = math.max(0, nInBat - nVeh) 
			
			if nToDiscard ~= 0 then
				repeat
					local item = math.random(2,nInBat)
					if selUnits[item] ~= -1 then
						nRem = nRem +1
						selUnits[item] = -1
					end
				until(nRem == nToDiscard)
			end

		end

		return selUnits
	end
	
	_cloneGroup:freeze(true)
	local cloneContDatas = _cloneAgDeagCont:getUserPrivateDatas(thisModule)
	-- build cloned bataillon private datas
	local cloneBatDatas = _cloneGroup:getUserPrivateDatas(thisModule)
	cloneBatDatas.mother = cloneContDatas.mother
	cloneBatDatas.task = cloneContDatas.task
	cloneBatDatas.dep = cloneContDatas.dep
	cloneBatDatas.des = cloneContDatas.des
	cloneBatDatas.targName = cloneContDatas.targName
	cloneBatDatas.agregated = false
	
	ATME.displayForAll(cloneBatDatas.mother:getName().." cloned as ".._cloneGroup:getName(),3)
			
	-- build deagregated bataillon version
	local unitsIndexTab = keepVeh(cloneBatDatas.task)
	cloneBatDatas.unitsIndexTab = unitsIndexTab
	-- cloneBatDatas.leadBatUnit = agregateGroup(_cloneGroup,unitsIndexTab, 2)
	cloneBatDatas.leadBatUnit = ATME.C_Alarm.schedule(1,agregateGroup,_cloneGroup,unitsIndexTab,2)
	_cloneGroup:addTrackingCallback(taskAtBatWPT)
	_cloneGroup:setOption("DISPERSE_ON_ATTACK",math.random(50,100))
	if cloneBatDatas.task == "ARMOR" then
		_cloneGroup:setOption("ROE","OPEN_FIRE")
		_cloneGroup:setOption("ALARM_STATE","RED")
	elseif cloneBatDatas.task == "SUPPORT" or cloneBatDatas.task == "ARTILLERY" then
		_cloneGroup:setOption("ROE","RETURN_FIRE")	
	end
	
	-- Eventually reveal position
	if math.random(1,10) <= 5 then
		local lat, lon, alt = ATME.convertPointToLL(cloneContDatas.dep)
		local latStr, lonStr = ATME.LLToDMdString(lat, lon)
		local message = "Ennemy ground forces spoted around Lon: "..lonStr.." Lat: "..latStr
		local coalToDisplay = nil
		if _cloneGroup:getCoalitionName() == "BLUE" then coalToDisplay = "RED" else coalToDisplay = "BLUE" end
		ATME.displayForCoalition(coalToDisplay, message, 30)
	end
	
	ATME.C_Alarm.schedule(math.max(2,cloneProcSpacing-2), delayUnfreeze)
	table.insert(createdBat,_cloneGroup)
end


local function buildIniBat(_motherGroup,_numClone)

	-- build route for cloned bataillon
	-- with at least deaparture (DEP) waypoint
	local routeName = _motherGroup:tagGetByID(1).."CloneRoute"
	cloneRoute = ATME.C_Route("GROUND",false)

	local stratTargName, depPos, desPos = nil, nil, nil
	if _motherGroup:tagGetByID(2) == "ARMOR" or _motherGroup:tagGetByID(2) == "SUPPORT" or _motherGroup:tagGetByID(2) == "ARTILLERY" then 

		-- Select departure position (DEP)
		stratTargName, depPos = selectPos(_motherGroup,"DEP",false)
		cloneRoute:addAbsoluteWaypoint(depPos,5,"ON_ROAD")
		cloneRoute:setNameToWaypoint(0,"DEP")
		
		-- Add destination waypoint (DES) if moving bataillon
		stratTargName, desPos = selectPos(_motherGroup,"DES",true)
		local speed = ATME.convertKphtoMps(math.random(80,120)*0.01*meanVehSpeed)
		cloneRoute:addAbsoluteWaypoint(desPos,speed,"ON_ROAD")
		cloneRoute:setNameToWaypoint(1,"DES")

	-- AAA and SAMs have only DEP WPT
	elseif _motherGroup:tagGetByID(2) == "AAA" or _motherGroup:tagGetByID(2) == "SAM" then
		-- Run the DES option but is a DEP WPT
		stratTargName, depPos = selectPos(_motherGroup,"DES",false)
		cloneRoute:addAbsoluteWaypoint(depPos,0,"OFF_ROAD")
		cloneRoute:setNameToWaypoint(0,"DEP")
		desPos = depPos
		
	end
		
	-- Prepare cloning contexts
	-- clone mother deagregated version
	local cloneBatName = _motherGroup:tagGetByID(1).." Bat".._numClone
	local cloneBatCont = ATME.C_CloningContext(_motherGroup:getName(),cloneBatName)
	cloneBatCont:addSpawnCallback(cloneAgDeagCallback)
	local cloneBatContDatas = cloneBatCont:getUserPrivateDatas(thisModule)
	cloneBatContDatas.mother = _motherGroup
	cloneBatContDatas.task = _motherGroup:tagGetByID(2)
	cloneBatContDatas.dep = depPos
	cloneBatContDatas.des = desPos
	cloneBatContDatas.targName = stratTargName
	
	-- clone bataillon and run cloneAgDeagCallback
	cloneBatCont:spawn(cloneRoute)

end


local function cloneBataillons()

	ATME.displayForAll("cloneBataillons function ",3)
	
	local cloneDelay = 1
	for c = 1, #coalitionTab do
	
		local coalSide = coalitionTab[c]
		for t = 1, #compagnyTaskTab do
		
			local batTask = compagnyTaskTab[t]
			local compGroupList, ncompGroupList = _G[coalSide..batTask.."compGroupList"], _G[coalSide..batTask.."compGroupList"]:getCount()
			local nCloneBat = math.floor(_G[coalSide..batTask.."frac"]*nMaxBat)
			
			-- Computing number of bataillons to clone
			-- Stocked in batToClone (for exemple with 3 kind of bataillons {1,4,2})
			if ncompGroupList ~= 0 and nCloneBat ~= 0 then
				-- choose the bataillons to clone
				local batToClone = {}
				-- at least one of each if possible
				local totBat = 0
				for b = 1, ncompGroupList do
					if b <= nCloneBat then 
						table.insert(batToClone,1) 
						totBat = totBat + 1
					end
				end
				-- then at random
				while (totBat < nCloneBat) do
					sel = math.random(1,#batToClone)
					batToClone[sel] = batToClone[sel] + 1
					totBat = totBat + 1
				end
				
				if #batToClone ~= 0 then
					for b = 1, #batToClone do
						local motherGroup = compGroupList:get(b)
						ATME.displayForAll(coalSide.." Mother bat / Nclones ==> "..motherGroup:getName().." / "..batToClone[b],3)
						for cl = 1, batToClone[b] do
							-- ATME.displayForAll("Cloning: "..cl.." delay: "..cloneDelay,1)
							ATME.C_Alarm.schedule(cloneDelay,buildIniBat,motherGroup,cl)
							cloneDelay = cloneDelay + 3
						end
					end
				end

			end
			
		end
			
	end
	
end

-- =====================
-- ONCREATEGROUP HANDLER
-- =====================
local function onCreateGroup(_Group, _respawned)

	local groupDatas = _Group:getUserPrivateDatas(thisModule)
	groupDatas.name = _Group:getName()
	groupDatas.category = _Group:getCategoryName()
	groupDatas.coalition = string.lower(_Group:getCoalitionName())
	groupDatas.nVehicle = _Group:getNbUnits()
	
	if groupDatas.category == "GROUND" then

		local tempTag = ATME.getTags(_Group:getName())
		groupDatas.batName = tempTag[1]
		groupDatas.task = string.upper(tempTag[2])
		groupDatas.coalition = string.lower(_Group:getCoalitionName())

		if iniTreat then
			-- Add group in compagny GroupList
			_G[groupDatas.coalition..groupDatas.task.."compGroupList"]:add(_Group)
		end

	end
	
end

-- ===============
-- ONTIMER HANDLER
-- ===============
local function onTimer()
	
	if ATME.getTime() > 8 then
	
		if iniTreat then
	
			ATME.displayForAll("onStart function: Starting bataillon cloning process\nBE PATIENT.........",3)
			cloneBataillons()
	
			iniTreat = false
		end
	end
end


-- ===============
-- ONSTART HANDLER
-- ===============
local function onStart()

	-- Sort table (usage: table.sort(tab2sort,tableSortCat))
	local function tableSortSurf( a, b)
		return (a.surf < b.surf)
	end

	-- Getting Areas
	-- =============
	for zoneName, zoneData in pairs(mist.DBs.zonesByName) do
	
		local tagsName = ATME.getTags(zoneName)
		local coalition = string.lower(tagsName[1])

		-- Get the areas availables
		if string.find(tagsName[2],"Area") then
			
			local surface = math.ceil(ATME.getDCSZone(zoneName).radius * ATME.getDCSZone(zoneName).radius)			
			table.insert(_G[coalition.."AreaTab"],{name = zoneName, surf = surface, prob = 0, listTarg = {}})
			-- ATME.displayForAll("DEBUG: "..coalition.." Area site '"..zoneName.."' FOUND\t"..#_G[coalition.."AreaTab"],3)
		
		elseif string.find(tagsName[#tagsName],"stratTarg") then
		
			table.insert(_G[coalition.."StratTargTab"],zoneName)
			--ATME.displayForAll("DEBUG: "..coalition.." strategic site '"..zoneName.."' FOUND\t"..#_G[coalition.."StratTargTab"],3)
		
		end
	end
	
	for c = 1, #coalitionTab do
	
		table.sort(_G[coalitionTab[c].."AreaTab"],tableSortSurf)
		local totSurf = 0.
		for z, zDatas in pairs(_G[coalitionTab[c].."AreaTab"]) do totSurf = totSurf + zDatas.surf end
		local cumProb = 0.
		for z, zDatas in pairs(_G[coalitionTab[c].."AreaTab"]) do 
			zDatas.prob = math.floor(zDatas.surf*100./totSurf+0.5) 
			zDatas.cumProb = cumProb + zDatas.prob
			cumProb = zDatas.cumProb
		end

		-- Now fill the area tables with targets
		for area, areaDatas in pairs(_G[coalitionTab[c].."AreaTab"]) do
			for str, strDatas in pairs(_G[coalitionTab[c].."StratTargTab"]) do
				if ATME.getTags(strDatas)[3] == ATME.getTags(areaDatas.name)[2] then
					table.insert(areaDatas.listTarg, strDatas)					
				end
			end
		end
	end

end

	
do
	ATME.displayForAll("DYNAMO: Dynamic Model mission engine\nPowerded by ATME V2.0\n Alpha module GGcombat",5)

	local newHandlers = {

		onCreateGroupHandler = onCreateGroup,
		onTimerHandler = onTimer,
		onStartMissionHandler = onStart,

    }
	thisModule = ATME.C_Module(moduleName, newHandlers, true)
	
	env.info("Test GGcombat")
	
 end
